//#include <jni.h>
//#include "ActiveSend.h"
#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>

#include "activePacket.h"

int S;
 

int main  ()
{ 
  struct hostent *h;
  struct sockaddr_in servAddr, cliAddr;
  unsigned char ttl = 16;
  int iret;
  activeSocketHandle_t *hActSock;

  char *maddr = "224.10.10.10";//(*env)->GetStringUTFChars(env,mcast_addr, 0);
  int port = 5000;

  h = gethostbyname (maddr);
  
  if (h==NULL)
    {printf("%s: Unknow host\n");
     exit (1);
    }

  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);
  servAddr.sin_port =htons(port);

  if(!IN_MULTICAST(ntohl(servAddr.sin_addr.s_addr)))
    { printf("%s: is not  multicast\n", maddr);
      exit(1);
    }

  S = socket (AF_INET,SOCK_DGRAM,0);

  if (S<0)
    { printf("cannot open socket\n");
     exit(1);
    }

  cliAddr.sin_family = AF_INET;
  cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  cliAddr.sin_port =htons (0);

  if (bind(S,(struct sockaddr *) &cliAddr, sizeof(cliAddr))<0)
    { printf("cannot bind socket\n");
      exit(1);
    }

  if (setsockopt(S,IPPROTO_IP,IP_MULTICAST_TTL,&ttl,sizeof(ttl))<0)
    { printf("cannot set ttl\n");
      exit(1);
      }

  iret = connect (S,(struct sockaddr *)&servAddr,sizeof(servAddr));

  if (iret<0)
    { printf("cannot connect socket\n");
     exit(1);
    }

  hActSock = activeSocket(&S,NATIVE_SOCKET,"Dyram_service","0.0.0.0");

  if (hActSock==NULL)
     return(-1);
    
  printf ("la socket est active");
  return;
    
}
