/**
 *  TANd_raw.java
 *
 *  tcp server waiting for data who doesn't use ANEP format (like
 *  standard web browser,...)
 *
 *  @author Jean-Patrick Gelas */

import java.net.*;
import java.io.*;

class TANd_raw extends Thread
{
    final static boolean  DBG = false;

    ServerSocket ss;
    int port;

    public TANd_raw( int port )
    {
	this.port = port;
    }

    public void run()
    {
        try {
            ss = new ServerSocket( port );
            System.out.println("TANd_raw : ready ...");
            while( true ) {
                Demultiplex_raw mplxr = new Demultiplex_raw( ss.accept() );
		if(DBG) System.out.println("TANd_raw : "+
					   "connection established.");
                mplxr.start(); // start service
	    }
        } catch (IOException e) {
            System.err.println( "TANd_raw : " + e );
        }
    }
} // class TAN_raw
