/**
 *  TANd_tcp.java
 *
 *
 *  @author Jean-Patrick Gelas
 */

import java.net.*;
import java.io.*;

class TANd_tcp extends Thread
{
    final static boolean  DBG = false;

    ServerSocket ss;
    int port;

    public TANd_tcp( int port )
    {
	this.port = port;
    }

    public void run()
    {
        try {
            ss = new ServerSocket( port );
            System.out.println("TANd_tcp : ready ...");
            while( true ) {
                Demultiplex mplx = new Demultiplex( ss.accept() );
		if(DBG) System.out.println("TANd_tcp : "+
					   "connection established.");
                mplx.start(); // start service
	    }
        } catch (IOException e) {
            System.err.println( "TANd_tcp : " + e );
        }
    }
} // class TAN_tcp
