class TLVCell extends TLVList {
  private TLV head;
  private TLVList tail;

  public TLVCell (TLV t, TLVList tl) { head = t; tail = tl; }

  public TLV head () { return head; }
  public TLVList tail () { return tail; }

  public int length () {
    if (tail == null)
/*      
    return head.getLength ();
    else return head.getLength () + tail.length ();
*/
      return head.getLength() + 4; /* +1 = 2 x 2bytes = 32 bit */
    else return head.getLength() + 4 + tail.length ();
  }
  
  public TLV find (int type) throws TLVNotFoundException {
    if (head.getType () == type)
      return head;
    else if (tail == null)
      throw new TLVNotFoundException ();
    else return tail.find (type);
  }
}
