package ibp;

//
// IBPProtocol.java
//
// Written by Yong Zheng.  May 2001
//

public interface IBPProtocol {
	int 	IBP_v031 =  0,		//Version
		IBP_ALLOCATE = 1,	
		IBP_STORE = 2,
		IBP_DELIVER = 3,
		IBP_STATUS =  4,
		IBP_SEND = 5,
		IBP_RECV = 6,
		IBP_REMOTE_STORE = 7,
		IBP_LOAD = 8,
		IBP_MANAGE = 9,
		IBP_NOP = -1,
		MAX_NUM_CMDS = 10,
		
		IBP_OK = 1,
		
		IBP_STABLE = 2,
		IBP_VOLATILE = 1,
		
		IBP_BYTEARRAY = 1,
		IBP_BUFFER = 2,
		IBP_FIFO = 3,
		IBP_CIRQ = 4,
		
		IBP_PROBE = 40,
		IBP_INCR = 41,
		IBP_DECR = 42,
		IBP_CHNG = 43,
		IBP_CONFIG = 44,
		
		IBP_READCAP = 1,
		IBP_WRITECAP = 2,
		
		IBP_ST_INQ = 1,
		IBP_ST_CHANGE = 2,	
		
		DEPOT_PASSWD_LEN = 16;
};
