/**
 * VideoMpegS.java
 *
 * @author Lionel Elmalih and Jean-Patrick Gelas
 */



import java.io.*;

class VideoMpegS extends Service 
{
    final static boolean DBG = true;

    byte [] localhostNameinBytes; // cache data for perf
    

    VideoMpegS() 
    {
	if(DBG) System.out.println( "VideoMpegS : build" );
	localhostNameinBytes = net.localhostName.getBytes();
    }

    public void run()
    {
	try {
	    while(!FINISHED) {

	        process(); // process ANEP packet's payload

		net.makeANEPkt( net.serviceNameinBytes, 
				net.srcId.getBytes(),
				net.destId.getBytes(),
				localhostNameinBytes,
				net.proxyTANId.getBytes(),
				net.getANEPkt().payload );

		forward(); // net.sendANEPkt_next();
		recv();    // wait for the next ANEP packet
	    }
	} catch (IOException e) {
            System.err.println( "VideoMpegS : run() " + e );
        }
	net.close();
	if(DBG) System.out.println("VideoMpegS : run() thread done.");
	
    }

    public void process()
    {
	//getANEPkt().payload
	if(DBG) net.display();
    }
} // class VideoMpegS




