/**
 *  TANd_tcp.java
 *
 *
 *  @author Jean-Patrick Gelas
 */

import java.io.*;
import java.net.*;

class TANd_tcp extends Thread
{
    final static boolean  DBG = false;
 
    ServerSocket ss;
    int port;

    public TANd_tcp( int port )
    {
	this.port = port;
    }

    public void run()
    {
        try {
	    if(TAMANOIRd.interfaceName == null)
		ss = new ServerSocket( port, TAMANOIRd.queueSize );
	    else {
		InetAddress ia = InetAddress.getByName(TAMANOIRd.interfaceName);
		ss = new ServerSocket( port, TAMANOIRd.queueSize, ia );
	    }
            System.out.println("TANd_tcp : ready ...");
            while( true ) {
                Demultiplex mplx = new Demultiplex( ss.accept() );
		if(DBG) System.out.println("TANd_tcp : "+
					   "connection established.");
                mplx.start(); // start service
	    }
	} catch (BindException e) {
	    System.err.println( "TANd_tcp :  Address already in use (use -if option)");
        } catch (IOException e) {
            System.err.println( "TANd_tcp : " + e );
        }
    }
} // class TAN_tcp
