/**
 * FwdS.java
 *
 * @author Jean-Patrick Gelas
 */



import java.io.*;

class FwdS extends Service 
{
    final static boolean DBG = false;

    FwdS() 
    {

	if(DBG) System.out.println( "FwdS : build" );
    }

    public void run()
    {
	name =        "Forward service";
	institution = "ENS Lyon";
	author =      "jp";
	date =        "2003";
	comment =    "";
	serverbroker ="localhost"; 

	try {
	    while(!FINISHED) {

		forward(); // send to the next node (TAN or dest)
		recv();    // wait for the next ANEP packet
	    }
	} catch (IOException e) {
            System.err.println( "FwdS : run() " + e );
        }
	net.close();
	if(DBG) System.out.println("FwdS : run() thread done.");
	
    }

    public void process()
    {
	if(DBG) net.display();
    }
} // class FwdS




