import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;
import inria.util.*;


public class Init_Session extends Thread 

{ ActiveSend as;
  String multicast_address;
  int socket;
 
 

  public Init_Session (String Multicast_address)
    { as=new ActiveSend();
      socket = as.init_socket(socket,Multicast_address,5432);
      this.multicast_address = Multicast_address;
    }

  public void  Send() throws UnknownHostException, IOException
  { byte [] payload ;
    int type = 3;
    ANEPacket anepacket;
    
    InetAddress localhost;
    localhost = InetAddress.getLocalHost();
    String srcId = localhost.getHostAddress();
    byte [] srcIdinBytes = srcId.getBytes ();

    byte [] desIdinBytes = multicast_address.getBytes ();
	
    String serviceName = "MulticastS"; // Nom  du Sercive Multicast
    String serviceBrocker = "http://140.77.15.124";
    String sbsn = new String (serviceBrocker + "/" + serviceName);
    byte [] srvNameinBytes = sbsn.getBytes();

    ByteArrayOutputStream baos = new ByteArrayOutputStream ();
    DataOutputStream dos = new DataOutputStream (baos);	 
    dos.writeInt(type);
    payload=baos.toByteArray();

    TANet net = new TANet ();
    net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
    anepacket = net.anepkt;
    
    byte []  buffer = new byte [4000];
    buffer = anepacket.marshall();//net.anepkt.marshall();
    int size   = buffer.length;
    System.out.println("J'envoie un Init_session ");
    as.write(socket,buffer,size,multicast_address,5432);
  }

  public void close_socket()
    {
       as.close_socket(socket);
    }

 public void run () {
     
     while (this.isAlive())
	 { 
	     try 
	       { Send ();
	       } catch (UnknownHostException e){System.out.println (e);
	         }catch (IOException e){System.out.println (e);}

	     try {
		       this.sleep(10000);
		   } catch (InterruptedException e){System.out.println (e);}
	 }
 }
 

}
