import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;



public class Multicast_Sender extends Thread {

    File f=null;
    FileInputStream in;

    ActiveSend as2;// Pour envoyer les paquet de donnees
    int socket2;
    int datasize=6000;
    
    long total_bytes_read=0;    
    long MAXSEQ;
    int  type=0;
    long seq=0;
    int repair=0;
    long maxseq=0;
    long rate=0;
    long file_size=0;

    static byte [] srvNameinBytes;
    static byte [] srcIdinBytes ;
    static byte [] recIdinBytes ;
    static String  recId;
    String serviceName;
    String serviceBrocker;
    String sbsn;
    String Multicast_Address;   
    
    DSCacheControl pkt;
    Unicast_Recv ur;

    long start_time;

    StreamStruct stream;    
    Send_Indicator si;
    byte ttl=32;       
    File f3 ;
    STest_Thread stest_thread ;

    long number_pktsent = 0 ;
    Calendar calendar3, calendar4;
    long elapsed_time1, waiting_time;
	
  public Multicast_Sender (String Multicast_address,  String sendFileName) throws 
    FileNotFoundException, UnknownHostException, UnknownHostException, SocketException, IOException
    {
     this.Multicast_Address = Multicast_address;
     serviceName = "MulticastS"; 
     serviceBrocker = "http://140.77.15.124";
     sbsn = new String (serviceBrocker + "/" + serviceName);
     srvNameinBytes = sbsn.getBytes();

     InetAddress localhost;
     localhost = InetAddress.getLocalHost();	// adresse source
     srcIdinBytes = (localhost.getHostAddress()).getBytes();
     
     recId=Multicast_address;
     recIdinBytes=recId.getBytes();   

     String logfile_name = "mSend.txt";
     File f2 = new File(logfile_name);

     f = new File(sendFileName);
     file_size = f.length();
     MAXSEQ= (long) file_size/(datasize) + 1;
     in = new FileInputStream(f);  

     as2 = new ActiveSend ();
     socket2 = as2.init_socket(socket2,Multicast_address,4000);
     
     
     stream = new StreamStruct(f,true);//  Structure d'information sur l' emetteur

     stream.maxseq=4;
    
     stream.lo = 0;
     si = new Send_Indicator (this);       
     ur = new Unicast_Recv (null, this, stream);

     String File_Name = "SThroughput_file.txt";
     f3 = new File (File_Name);    
     stest_thread = new STest_Thread (stream,f3); 
   }
   

   public void start ()
    { si.start();
      Calendar calendar = Calendar.getInstance();
      start_time = calendar.getTimeInMillis();
      System.out.println("Start Sending"); 
      stest_thread.start();
      super.start();
    }

    public void sendpkt(long seq, int bytesread, byte [] dat) throws IOException
    {          
       ByteArrayOutputStream baos = new ByteArrayOutputStream ();
       byte [] payload ;




       DataOutputStream dos = new DataOutputStream (baos);



       TANet net = new TANet ();


       maxseq = stream.lo ;// Le dernier paquet aquitt


       dos.writeInt(type);


       dos.writeInt(repair);

       dos.writeLong(seq);

       dos.writeLong(maxseq);

       dos.writeLong(rate);

       dos.writeInt(bytesread);

       dos.writeLong(file_size);


       for (int i=44;i<(bytesread+48);i++)
	   dos.write(80);
      
       payload=baos.toByteArray();

       for (int k=0; k<bytesread; k++ )
	   payload[k+44]= dat[k];
      

       net.makeANEPkt(srvNameinBytes,srcIdinBytes,recIdinBytes,recIdinBytes,recIdinBytes,payload);    
       byte []  buffer = net.anepkt.marshall();                                 
       as2.write(socket2,buffer,buffer.length,Multicast_Address,4000);     
     
       /**On envoie les donnes sans le format ANEP**/

       /*ByteArrayOutputStream baos = new ByteArrayOutputStream ();
       byte [] payload ;
       DataOutputStream dos = new DataOutputStream (baos);       
       maxseq = stream.lo ;// Le dernier paquet aquitt
       dos.writeInt(type);
       dos.writeInt(repair);
       dos.writeLong(seq);
       dos.writeLong(maxseq);
       dos.writeLong(rate);
       dos.writeInt(bytesread);
       dos.writeLong(file_size);

       for (int i=44;i<(bytesread+44);i++)
	   dos.write(80);
		
       payload=baos.toByteArray();

       for (int k=0; k<bytesread; k++ )
	   payload[k+44]= dat[k];

       as2.write(socket2,payload,payload.length,Multicast_Address,4000); */

       /****************************************************************/
      
       /*On arrete a pour eviter le probleme de memoire momentanement*/
       /*DCacheControl pkt= new DCacheControl(seq , anepacket);	      
       stream.dcache.addElement(pkt);*/	      
       
       
     }

    public void run () 
    {  
	
    try {

	 int bytesread=0;
	 byte [] dat = new byte [datasize];


	 Calendar calendar = Calendar.getInstance();
	 long     start_time = calendar.getTimeInMillis();	
 
	 while ((bytesread=in.read(dat))!=-1)
	  {    
	      seq++;
	      total_bytes_read = total_bytes_read + bytesread;	       
	      sendpkt(seq,bytesread,dat);
	      stream.M++;               
	  } 

	 Calendar calendar2 = Calendar.getInstance();
	 long end_time = calendar2.getTimeInMillis();
	 long elapsed_time = end_time - start_time;
	 long all_data = (datasize+44)*seq;
	 float throutput = (all_data*8)/(elapsed_time);
	 throutput = (throutput*1000)/1024;
	 throutput = throutput/1024;
	 System.out.println("Debit global="+throutput+" Mbit/S");
	 System.out.println("last seq="+seq);
	 System.out.println("all_data="+all_data);
	 System.out.println("elapsed_time="+elapsed_time);
	
	stest_thread.stop();		
	si.stop();

	
       }catch (IOException e){System.out.println (e);
        }//catch (InterruptedException e){System.out.println (e);}
    
    
      
    }
    
}







