import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;


class Repair_Recv  extends Thread
{
  DatagramSocket ds;
  static final int MAX_SIZE = 4000;
  static byte[] payload = new byte[MAX_SIZE];
  Multicast_Recv multicast_recv;
  LOClient loclient;

  Repair_Recv(Multicast_Recv multicast_recv) throws SocketException
    { this.ds = new DatagramSocket(5001);
      this.multicast_recv=multicast_recv;
    }

   protected void notifyNewLO (long lo) throws IOException  
    {
	NewLOEvent evt = new NewLOEvent(this,lo); 
	NewLOListener listener = (NewLOListener) this.loclient;
        listener.NewLO(evt,this.multicast_recv.stream);
    }

    public void repairPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
    {
     /*On le remet au dataPktHandler on vera apres*/
     byte [] buffer = anepkt.marshall();
     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
     DataInputStream dis = new DataInputStream( bais );
     int type = dis.readInt();
     int repair=dis.readInt();
     long seq=dis.readLong();
     //System.out.println("Le repair "+seq+" est recue");
     long maxseq = dis.readLong();
     long rate = dis.readLong();
     int bytesread=dis.readInt();
     multicast_recv.dataPktHandler(anepkt);
     multicast_recv.dataPktHandler(anepkt);
     multicast_recv.N++;
    
    }


  public void run ()
    { 
      DatagramPacket dp = new DatagramPacket(payload, MAX_SIZE);
      ANEPacket anepkt;
      TANet net = new TANet();

     
      while ((this.isAlive())&&(multicast_recv.stream.Session_End==0))
        { 
	   try {
		  ds.receive(dp);  		  		  
		  anepkt=ANEPacket.unmarshall(dp.getData());		  
		  repairPktHandler(anepkt); 
	  		  
	      }catch (IOException e) {System.out.println (e);
	         }catch (BadANEPversionException e) {System.out.println (e);}

       }

      System.out.println("100%");

    }


}




