import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class Test_Thread extends Thread {

    Unicast_Sender us;
    StreamStruct stream;
    int crtimer ;
    File f;
    FileOutputStream out=null;
    int time = 1;
    int datasize=6000;

    public Test_Thread (StreamStruct stream, File f) throws FileNotFoundException 
    { 
      this.f = f;
      this.stream = stream;          
      this.out =  new FileOutputStream (f); 
    }
    

     public void start ()
     {
       System.out.println("Test_Thread start");
       super.start();       
     }


    public void run ()  
     { 
	 try
	    {
			
		while ((this.isAlive())&&(!stream.Complete()))  
		    {    	  
		       	   this.sleep(10000);
			   float throughput = stream.M*(((datasize+156)/1024)*8);
			   throughput = throughput/10;

			   if (throughput>1024)//On peut l'exprimer en Mbits/S
			    throughput = throughput/1024;
   
			   String message=(""+time+'\t'+throughput+'\n');
			   this.out.write (message.getBytes());
			   time = time + 1 ;
			   stream.M_total=stream.M_total+stream.M;
			   stream.M = 0;  
			   
		    }
			

	      }catch (InterruptedException e){System.out.println (e);
	        }catch (UnknownHostException e){System.out.println(e);
		  }catch(SocketException e) {System.out.println(e);
		    }catch(IOException e) {System.out.println(e);
		      }      
       
	
     }


    


 }
