import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;

public class Unicast_Recv extends Thread {
    Multicast_Recv MR;
    Multicast_Sender MS;
    StreamStruct stream;
    File f;
    DatagramSocket ds;
    static int port   = 5000;
    static byte [] srvNameinBytes;
    static byte [] srcIdinBytes ;
    String srcId;
    String desId;
    TANet net;
    long file_size;
    Unicast_Sender usend;
    Timers_Thread nackCheker=null;
    final static Hashtable LS = new Hashtable();// La table des liens descendants (Links Structure)
    LOClient loclient;
    int Session_End=0;
    Repair_Recv repair_recv;    
    Init_Session is;
    long old_maxseq;
    int datasize=6000;

    public Unicast_Recv (Multicast_Recv MR, Multicast_Sender MS,StreamStruct stream) throws UnknownHostException, SocketException
    { 
      this.stream = stream;
      this.loclient = new LOClient();
      
      
      if (!stream.sender)
      {this.MR = MR;
       this.repair_recv = new Repair_Recv(this.MR);
      }
      else
       {this.MS=MS;
        is = new Init_Session (MS.recId);// Je cre un objet Init_Session 
       }       
       
      
      this.f = stream.f;
      String serviceName = "MulticastS"; // Nom  du Sercive Multicast
      String serviceBrocker = "http://140.77.15.124";
      String sbsn = new String (serviceBrocker + "/" + serviceName);
      this.srvNameinBytes = sbsn.getBytes();
      
      InetAddress localhost;
      localhost = InetAddress.getLocalHost();
      this.srcId = localhost.getHostAddress();
      this.srcIdinBytes = srcId.getBytes();
      
      this.ds = new DatagramSocket(port);
      this.net = new TANet ();
      this.usend= new Unicast_Sender();
     
      if (!stream.sender)
      this.nackCheker = new Timers_Thread (usend,stream);

    }

    public void start ()
    {  
       if(!stream.sender)
       {nackCheker.start();
        repair_recv.start();
       }
       else
	is.start();

       super.start();
     }


    

   
    public void nackPktHandler (long seq) throws IOException, UnknownHostException
    {   
	ANEPacket anepkt=null;
       
	byte [] payload ;
	byte [] dat=new byte [datasize];
	DCacheControl pkt;
        int type = 0;
        int repair=1;
	int bytesread;
        long maxseq=0;
	long rate=0;
	file_size=f.length();
	long x = (long) file_size/datasize;

	if (seq <= x)
	{  bytesread = datasize;
	   /*else
	       bytesread = (int) (file_size - (x*1000));*/

	  
	
	if (seq<stream.minseq)
	 { 
	    FileInputStream in = new FileInputStream(f);
	    long current = datasize*(seq-1);
	    in.skip(current);
	    in.read(dat,0,datasize);
	    maxseq = stream.maxseq;
	  
	    ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	    DataOutputStream dos = new DataOutputStream (baos);
	    repair=1;
	    dos.writeInt(type);
	    dos.writeInt(repair);
	    dos.writeLong(seq);
	    dos.writeLong(maxseq);
	    dos.writeLong(rate);
	    dos.writeInt(bytesread);
	    dos.writeLong(file_size);
   
	    for (int i=44;i<(bytesread+44);i++)
		dos.write(80);
	  
	    payload=baos.toByteArray();
	  
	    for (int k=0; k<bytesread; k++ )
	      payload[k+44]= dat[k];
	       
	    net.makeANEPkt(srvNameinBytes,srcIdinBytes,srcIdinBytes,
						    srcIdinBytes,srcIdinBytes,payload);
	    anepkt=net.anepkt;

	 }
	else
	   { for (int i=0; i<stream.dcache.size();i++)
	      { pkt =  (DCacheControl) stream.dcache.elementAt(i);

	        if (pkt.seq==seq)
	        
		{ anepkt=pkt.anepkt;
		  break;
	        }

	      }

	     
	     if (anepkt==null)
	       {		   
	          FileInputStream in = new FileInputStream(f);
		  long current = datasize*(seq-1);
		  in.skip(current);
		  in.read(dat,0,datasize);
		  maxseq = stream.maxseq;
	  
		  ByteArrayOutputStream baos = new ByteArrayOutputStream ();
		  DataOutputStream dos = new DataOutputStream (baos);
		  repair=1;
		  dos.writeInt(type);
		  dos.writeInt(repair);
		  dos.writeLong(seq);
		  dos.writeLong(maxseq);
		  dos.writeLong(rate);
		  dos.writeInt(bytesread);
		  dos.writeLong(file_size);
   
		  for (int i=44;i<(bytesread+44);i++)
		      dos.write(80);
	  
		  payload=baos.toByteArray();
	  
		  for (int k=0; k<bytesread; k++ )
		      payload[k+44]= dat[k];
	       
		  net.makeANEPkt(srvNameinBytes,srcIdinBytes,srcIdinBytes,
						    srcIdinBytes,srcIdinBytes,payload);
		  anepkt=net.anepkt;

	       }
	     else
	     { ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	       DataInputStream dis = new DataInputStream( bais );

	       type=dis.readInt();
	       repair=dis.readInt();
	       seq=dis.readLong();
	       maxseq = dis.readLong();
	       rate = dis.readLong();
	       bytesread=dis.readInt();
	       file_size=dis.readLong();

	       ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	       DataOutputStream dos = new DataOutputStream (baos);

	       repair=1;
	       dos.writeInt(type);
	       dos.writeInt(repair);
	       dos.writeLong(seq);
	       dos.writeLong(maxseq);
	       dos.writeLong(rate);
	       dos.writeInt(bytesread);
	       dos.writeLong(file_size);
	     
	       for (int i=44;i<(bytesread+44);i++)
		   dos.write(80);
		
	       payload=baos.toByteArray();

	       for (int k=0; k<bytesread; k++ )
	       payload[k+44]= anepkt.payload[k+44];
	    
	       net.makeANEPkt(srvNameinBytes,srcIdinBytes,srcIdinBytes,
						    srcIdinBytes,srcIdinBytes,payload);
	       anepkt= net.anepkt;
	       //System.out.println("Le paquet "+seq+" est renvoye a partir du cache");
	      }
	    }
        
	
	
	 usend.SendRepair(this.desId,anepkt);
	 
	}
      }


    protected void notifyNewLO (long lo) throws IOException  
    {
	NewLOEvent evt = new NewLOEvent(this,lo); 
	NewLOListener listener = (NewLOListener) this.loclient;
        listener.NewLO(evt,stream);
    }



    public void crPktHandler(ANEPacket anepkt) throws IOException
    {
   
    ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
    DataInputStream dis = new DataInputStream( bais );

    int type = dis.readInt();
    long lo  = dis.readLong();
    long lr  = dis.readLong();
    long Maxseq = dis.readLong();
    double rtt2s  = dis.readDouble();
    long rtt2p  = dis.readLong();
    long period = dis.readLong();
    double var_rtt=dis.readDouble();

    stream.lo= lo;
    stream.lr= lr;    
    
    stream.rtt2s=rtt2s;
    stream.rtt2p=rtt2p;
    stream.period=period;
    stream.var_rtt=var_rtt;     
     
     if (lo>stream.lo)
	 {stream.lo=lo; 
	  notifyNewLO(lo);
	 }
    
     
    if (Maxseq>stream.maxseq)
    stream.maxseq = Maxseq;

    //System.out.println("CR Pkt received  Maxseq="+stream.maxseq); 

    /****************************************************/
    /**Solution pour caclculer le RTTS,RTTP,et Var RTT***/
    /****************************************************/

    /*double deltaq = (var_rtt*stream.rate)/1000;
    

    if (deltaq<0.2)// On augmente le dbit
	{
	 double new_rate = stream.rate + (stream.rate/rtt2s);
	 if (new_rate<100) // La borne superieure RateMax
	     stream.rate=new_rate;
	}

    System.out.println("deltaq="+deltaq+" new rate="+stream.rate);    */
      
    
    /*********************************************/
    /*On va laisser la taille de la fentre  32*/
    /********************************************/
    /*if (maxseq>stream.maxseq)
	{ stream.window_size=(maxseq - stream.maxseq); // On met  jour la taille de la fentre
	  stream.maxseq=maxseq;// On met  jour le champ maxseq
	  System.out.println("new window_size="+stream.window_size+" new maxseq="+stream.maxseq);
	 }*/

    

    }

    public void repairPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
    {
     byte [] buffer = anepkt.marshall();
     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
     DataInputStream dis = new DataInputStream( bais );
     int type = dis.readInt();
     int repair=dis.readInt();
     long seq=dis.readLong();
     long maxseq = dis.readLong();
     long rate = dis.readLong();
     int bytesread=dis.readInt();
     long file_size=dis.readLong();
     MR.dataPktHandler(anepkt);
     MR.N++;
     System.out.println("N mies a jour");
     TANet net = new TANet();
     net.anepkt= anepkt;
     net.recoverInfoFromANEPkt();    
    }


    
    /*Traitement des paquets Init_Resp recues */

    public void Init_RespPktHandler (ANEPacket anepkt) throws IOException
    {     

      if(this.is.isAlive())
	  {   is.close_socket();
	      this.is.stop ();
	  }

      if (!this.MS.isAlive())
	  this.MS.start();

      TANet net = new TANet();
      net.anepkt=anepkt;
      net.recoverInfoFromANEPkt ();
      //System.out.println("J'ai un noeud fils "+net.srcId);
      
      if (!LS.containsKey(net.srcId)) /*C un nouveau noeud on le met dans Link List*/
	  { LrLo lrlo = new LrLo ();
	    LS.put(net.srcId, lrlo );
	  }     
      
     }
   

    public void Session_End (ANEPacket anepkt) throws IOException
    { 
      stream.Session_End=1;
    }

    public void HBPkt_RespHandler (ANEPacket anepkt) throws IOException
    { 
      Calendar calendar2 = Calendar.getInstance();	    
      long receive_time = calendar2.getTimeInMillis();	
      
      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
      DataInputStream dis = new DataInputStream( bais );
      int type = dis.readInt();		
      long time_stamp = dis.readLong(); 
      long rtt2p = dis.readLong();
      long rtt2s = (receive_time - time_stamp)+rtt2p;         

      System.out.println("rtt2s="+rtt2s);

      if (MR.stream.rtt2s==0)
        MR.stream.rtt2s = rtt2s;        
      else     
        MR.stream.rtt2s = (MR.stream.rtt2s*0.9)+(rtt2s*0.1); // On applique le Smooth RTT de TCP     
    }   

   
    public void run () {

	byte[] buffer = new byte [160];
	DatagramPacket dp = new DatagramPacket (buffer, buffer.length);
	ANEPacket anepkt=null;
	
	int type;
	long seq;
	long lo = 0 ;
	long lr = 0  ;
	long maxseq = 0;
	long rate = 0;
	int repair ;
	FileInputStream in = null;
	byte [] dat=new byte [datasize];
	int bytesread = 0 ;
	long file_size;
	int payloadSize = 4*1024;
	byte [] payload ;
	byte [] buffer2  ;
	
	file_size = f.length();	
	
	while ((this.isAlive())&&(stream.Session_End==0))
	       { 
	       
	         try{ ds.receive(dp);     
		      buffer =dp.getData();      
		      anepkt=ANEPacket.unmarshall(buffer);
		      
		      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
		      DataInputStream dis = new DataInputStream( bais );
		      type = dis.readInt();
		      net.anepkt=anepkt;
		      net.recoverInfoFromANEPkt ();
		      this.desId=net.srcId;		      

		      /*Le paquets repair sont envoys sur le port 5001*/

		      /*if (type==0)
		      repairPktHandler(anepkt);*/
		      
			   
		      if (type==1) 
		          
			  {  seq=dis.readLong();
		             /*lo =dis.readLong();
			     lr =dis.readLong();
			     maxseq = dis.readLong();*/
			     System.out.println("NACK ("+seq+") from "+net.srcId);			    
		             nackPktHandler(seq);
			  }

		      if (type==2)		         
			  crPktHandler(anepkt);
		      

		      /*if (type==3)
		         
			  Init_RespPktHandler (anepkt);*/		       
		      
		      
		      if (type==4)
		      
			  Session_End (anepkt);

		      /*if (type==5)
		      {long time_stamp =  dis.readLong();
		       usend.SendHBPkt_Resp(net.srcId,time_stamp);
		      }*/

		      /*if(type==6)
		      {   
			  HBPkt_RespHandler (anepkt);
		      }*/
		      
		    }catch (IOException e) {System.out.println (e);
	              }catch (BadANEPversionException e) {System.out.println (e);}
		      
	      }

	if(!stream.sender)
	stream.Unicast_End=1;

	//System.out.println("Unicast_Recv est fini");

	/*if(!stream.sender)
	{ repair_recv.stop();
	  nackCheker.stop();
	  }*/
    }


    




}








