/**
 *  natLSO.cc
 *
 *
 *  @author Jean-Patrick Gelas
 */



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dlfcn.h>
#include <sys/ioctl.h>

#include <stream.h>

#include <java/io/PrintStream.h>
#include <java/lang/String.h>
#include <java/lang/System.h>
#include <cni.h>

#include "LSO.h"

void * hdl;
char * error;  

void LSO::loadSharedObject ( ::java::lang::String * name ) 
{
  jsize len = JvGetStringUTFLength( name );
  char * buf = (char *)malloc( len + 1 );

  memset(buf, 0, len);	
  JvGetStringUTFRegion(name, (jsize)0, len, buf);

  hdl = dlopen ( buf , RTLD_LAZY);
  if (!hdl) {
    fputs (dlerror(), stderr);
    exit(1);
  }
} // loadSharedObject()

