import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class CRThread extends Thread {

    Unicast_Sender us;
    StreamStruct stream;
    int crtimer ;
    

    public CRThread (Unicast_Sender us, StreamStruct stream)
    { 
      this.us = us;
      this.stream = stream;      
      this.crtimer = 100;
      
      
    }
    

     public void start ()
     {
	 System.out.println("CRThread start");
       super.start();
       
     }


    public void run ()  
     { 
	 try
	    {
		while (this.isAlive())  
		    {    	  
			crtimer--;
		        
			if ((crtimer==0)&&(stream.lr!=stream.maxseq))
			    {   
				us.SendCR(stream.emetteur,stream.lo,stream.lr,stream.maxseq,stream.rtt2s,stream.rtt2p,stream.period,stream.var_rtt);
				
				System.out.println("CR Pkt is Sent Maxseq="+stream.maxseq+" lr="+stream.lr);
				crtimer=100;
			    }
		
			    

			this.sleep(10);

		    }
			

	      }catch (InterruptedException e){System.out.println (e);
	        }catch (UnknownHostException e){System.out.println(e);
		  }catch(SocketException e) {System.out.println(e);
		    }catch(IOException e) {System.out.println(e);
		      }catch (BadANEPversionException e){System.out.println(e);}

	

       
       
	
     }


    


 }
