import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Calendar;
import java.text.DateFormat;


public class Multicast_Recv extends Thread {

     File f =null;    
     static NVector nackCache;
     Client client;
     String emetteur=null;
     StreamStruct stream;
     MulticastSocket mrs; 
     int recep_socket_size;
     Indicator indicator;
     Unicast_Recv ur;
     int N = 0; 
     int datasize = 6000;
     String pere = null;
     long start_time = 0;
     long end_time   = 0; 
     int first =0;
     LOClient loclient;
     long MAXSEQ;
     ActiveReceive ar;    
     HB_Thread hb_thread;
     long first_time, last_time, period_start, period_end ; 
     long period;
     int counter = 0;
     double old_rtt2s=0;

     long last_pkt_ack_by_sender = 0; // stock le maxseq recue dans les paquets data
     long old_last_pkt_ack_by_sender = 0;
     long diff = 0;
     long Maxseq = 0 ;
     CRThread crthread = null;

     String File_Name = "Throughput_file.txt";
     File f2 = new File (File_Name);
    Test_Thread test_thread ;
     

    public Multicast_Recv (String Multicast_address, String recvFileName)throws UnknownHostException, SocketException,FileNotFoundException,IOException
      
    {
	InetAddress multicast_address;
	multicast_address = InetAddress.getByName (Multicast_address);	
        mrs = new MulticastSocket (4000);
	
	mrs.joinGroup(multicast_address);
	mrs.setSoTimeout(4000);
	
	f = new File(recvFileName);
	stream = new StreamStruct(f,false);// C une structure de recepteur

	test_thread = new Test_Thread (stream,f2);

	recep_socket_size = mrs.getReceiveBufferSize();
	int initial_window_size = (int) (recep_socket_size/(datasize+156));
	System.out.println("initial window size="+initial_window_size);

	recep_socket_size = recep_socket_size*1000;// On multiplie la taille du buffer par 1000
	mrs.setReceiveBufferSize(recep_socket_size); 
	/*On verifie si c'est bon*/
	//recep_socket_size = mrs.getReceiveBufferSize();
	//stream.window_size= (recep_socket_size/(datasize+156));
	//stream.avail_window_space_size = stream.window_size;
	//System.out.println("available window size="+stream.avail_window_space_size);

	this.nackCache = new NVector(); // notre cache des Nacks emis (sans reponse biensure)
	this.client = new Client ();
	this.indicator = new Indicator (stream);
	this.ur = new Unicast_Recv(this,null,stream);
	this.loclient = new LOClient();
	crthread = new CRThread(ur.usend,stream);
	
	
	      
    }
	  

    public void start ()
     { 
       indicator.start();
       ur.start();
       test_thread.start ();
       super.start();
       
     }

    
    
    public void PktOrder () throws IOException  
    {
	int i = 0;
	DCacheControl pkt;
	
	while (i<stream.dcache.size())
	    { pkt = (DCacheControl) stream.dcache.elementAt(i);
	    
	      if ((pkt.seq==stream.lo+1)&&(pkt.anepkt!=null))
		  {
		   notifyNewPacket (pkt.anepkt);
		   stream.lo++;
		   //dataStream.rfwrite(pkt.seq);
		   pkt.packetDeliveredToApplication=true;
		   i=0;/*reprendre le teste du debut*/
		  }
	      else
		  i++;  
	    }
    
    }	
 

    protected void notifyNewPacket (ANEPacket anepkt) throws IOException  
    {
	NewPacketEvent evt = new NewPacketEvent(this,anepkt); 
	NewPacketListener listener = (NewPacketListener) this.client;
        listener.NewPacket(evt,stream);
    }




   public int findPkt (long seq)
    {
	DCacheControl pkt;
	int index = -1;

	for (int i=0;i<stream.dcache.size();i++)
	    { 
	      pkt = (DCacheControl) stream.dcache.elementAt(i);
	      
	      if (pkt.seq==seq)
		  { index = i ;
		    break;
		  }
	    }

	return (index);

    }


   public void InitReqHandler (ANEPacket anepkt) throws IOException, BadANEPversionException 
    { TANet net = new TANet ();
      net.anepkt=anepkt;
      net.recoverInfoFromANEPkt ();
      System.out.println("la session est initialisee");
      ur.usend.SendInit_Resp(net.srcId);      
      pere = net.srcId;  
    }

   public float  moyenne (long [] tab, int n)
    { 
      long somme=0;

      for(int i=0;i<n;i++)
       somme = somme+tab[i];    

      float moy = (float)(somme/n);
      
      return (moy);
    }

   
  protected void notifyNewLO (long lo) throws IOException  
    {
	NewLOEvent evt = new NewLOEvent(this,lo); 
	NewLOListener listener = (NewLOListener) this.loclient;
        listener.NewLO(evt,stream);
    }

    
 public void dataPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
     {   	
	int type = 0 ;
	long seq = 0 ;
	long maxseq = 0;
	long rate = 0;
	int repair  = 0;
	long file_size = 0;
	int bytesread = 0;
	int index = 0 ;
        DCacheControl pkt;
	NCacheControl nack;
	TANet net = new TANet ();
	
	ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	DataInputStream dis = new DataInputStream( bais );	
	//last_time = new TimeC().TempsSys();
	type=dis.readInt();
	repair = dis.readInt();
	seq=dis.readLong();
	last_pkt_ack_by_sender = dis.readLong();
	rate   = dis.readLong();
	bytesread = dis.readInt();
	file_size = dis.readLong();

	if((stream.file_size<=0)&&(file_size>0)&&(repair==0))
	{stream.file_size = file_size;
	 MAXSEQ= (long) file_size/1000 + 1;
	}


	stream.M++ ;  

	net.anepkt=anepkt;
	net.recoverInfoFromANEPkt ();	

	/*suprimer le timer du Nack correspondant au paquet recue*/

	
	 for (int i=0;i<stream.nackCache.size();i++)
	    {  
	       
	       nack = (NCacheControl) stream.nackCache.elementAt(i);
		          
	       if (nack.seq == seq)
	       { nack.received=true;
		 stream.nackCache.removeElementAt(i);
		 break;
		 //dataStream.nrwrite(seq);
	       }
	     }


	if (seq>stream.lo)
        {  pkt = new DCacheControl(seq , anepkt);
	   index = findPkt(seq);

	   if (index==-1) // on a un nouveau paquet
	     { 
		 /*mettre le paquet ANEP dans le buffer*/
		 //dataStream.rwrite(seq);
	         stream.dcache.addElement( pkt);

	     }    

	    if (seq==stream.lo+1)
	     { //declencher un evt NewPacket pour le mettre dans le fichier
	       notifyNewPacket (pkt.anepkt);
	       stream.lo++;
	       
	       //dataStream.fwrite(seq);
	       pkt.packetDeliveredToApplication=true;
	       
	       //Verifier l'ordre des autres paquets dans le buffer
	       PktOrder();
	     }

	     /*mettre a jour le minseq*/
	     if (stream.minseq==0)
		    stream.minseq = seq;
	     else
		if(seq<stream.minseq)
		    stream.minseq = seq;     

	     stream.lr = seq;



	    /*mettre a jour le next */     
	      if (seq==stream.next)
		{  if (MAXSEQ>0)
		    { if (stream.next<MAXSEQ)			
			{stream.next++;
			 //System.out.prin("packet("+seq+") is received");
			}
		    }
		   else
		      stream.next++;
		
		}

	     /*mettre les paquet en retard ou perdue dans le nackCache*/

	     if (seq>stream.next)
	     { 
		 for (long j=stream.next;j<seq;j++)
		  { nack = new NCacheControl(j,emetteur);
		    stream.nackCache.addElement(nack);
		    ur.usend.SendNack(stream.emetteur,j,stream.lo,stream.lr,stream.maxseq);    
		    System.out.println("packet("+j+") is lost");
		  }
			 
	         stream.next = seq+1;
	     }                  
		     
         }


	if (N==2) 

	{ 	  	  
	  Calendar calendar_period1 = Calendar.getInstance();	    
	  period_end = calendar_period1.getTimeInMillis();	  
	  period = period_end - period_start ;
	  stream.period=period;	   

	  /*stream.avail_window_space_size = stream.avail_window_space_size + (diff-16);
	  
	      if (stream.avail_window_space_size==0)
	      System.out.println("window closed");*/   
	      

	  stream.maxseq = stream.lr + N; // stream.avail_window_space_size;	  
	  
	  N=0;

	  //notifyNewLO(stream.lo); 
	  
	  double var_rtt = stream.rtt2s - old_rtt2s;
	  stream.var_rtt = var_rtt;
	 	  
	  ur.usend.SendCR(stream.emetteur,stream.lo,stream.lr,stream.maxseq,stream.rtt2s,stream.rtt2p,
			  stream.period,stream.var_rtt);

	  //System.out.println("CR Pkt is Sent Maxseq="+stream.maxseq);
	  
	  old_rtt2s=stream.rtt2s;
	  stream.rtt2s=0;
	  //System.out.println("var_rtt="+stream.var_rtt);	  
	  Calendar calendar_period2 = Calendar.getInstance();
	  period_start = calendar_period2.getTimeInMillis();
	}



    }


   
    public void receiveDataPacket () throws IOException, BadANEPversionException,SocketException
     {
        
        ANEPacket anepkt;
	int type=0;
        NCacheControl nack;
	TANet net = new TANet ();
	byte [] buffer= new byte [4000];
	DatagramPacket dp=new DatagramPacket(buffer, buffer.length);
	

	try{ 
	    mrs.receive(dp);        

	    if (counter==0)
	    { Calendar calendar10 = Calendar.getInstance();	    
	      first_time = calendar10.getTimeInMillis();
	      counter++;
	    }
	    
	    if(counter==10)
	       { Calendar calendar20 = Calendar.getInstance();
		 //last_time=calendar20.getTimeInMillis();
		 //long rate10= last_time - first_time;
		 //Calendar calendar10 = Calendar.getInstance();	    
		 //first_time = calendar10.getTimeInMillis();
		 counter=0;
		 //stream.rate=rate10;
		 //System.out.println("rate10="+rate10);		 
	       } 
       
	    if((counter>0)&&(counter<10))
		 counter++;
	     
	        
	     anepkt=ANEPacket.unmarshall(buffer);
	     net.anepkt=anepkt;
	     net.recoverInfoFromANEPkt ();      
	      	      
	     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);	      
	      
	     DataInputStream dis = new DataInputStream( bais );	      	      	      

	     type = dis.readInt();                  
	     
	     if (type==0)
	     {  
	       

		if(first==0)
		  { first = 1;
		    stream.emetteur= net.srcId;
		    this.emetteur=net.srcId;
		    hb_thread = new HB_Thread (stream.emetteur,ur.usend);
		    //hb_thread.start();// On verra a plus tard
		    Calendar calendar = Calendar.getInstance();
		    start_time = calendar.getTimeInMillis();
		    period_start = start_time;// Utile pour calculer la periode		    
		  }
		
		 dataPktHandler (anepkt);		
	         N++;
 	         
	       } 
		
	      if (type==3)
		  InitReqHandler(anepkt); 
	      
	   } catch(SocketTimeoutException e)
	      {
	       if ((stream.next>1)&& (!stream.Complete()))
	       {nack = new NCacheControl(stream.next,emetteur);
		nackCache.addElement(nack);
		ur.usend.SendNack(stream.emetteur,stream.next,stream.lo,stream.lr,stream.maxseq);
		System.out.println("packet("+stream.next+") is too late");
               }
	      }
         

  }

  
   
 public void run ()  
   {
      

    try {

	    
	   while (!stream.Complete())
	      receiveDataPacket ();
	      
	}catch (IOException e){ System.out.println (e);
	  }catch (BadANEPversionException  e) { System.out.println (e);}

    try {
         ur.usend.Send_SessionEnd(stream.emetteur);
       }catch (IOException e){ System.out.println (e);
        }catch (BadANEPversionException  e) { System.out.println (e);}

     Calendar calendar2 = Calendar.getInstance();
     end_time = calendar2.getTimeInMillis();
     long elapsed_time = end_time - start_time;
           
     elapsed_time = elapsed_time/1000;
     float mean_rate = (stream.M_total*9)/elapsed_time;
     System.out.println("Mean Rate="+mean_rate);
     System.out.println("Elapsed Time="+elapsed_time);
    
    
   }	



}









