import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;
import inria.util.*;


public class Sender_Thread extends Thread {

    File f;
    ActiveSend as;
    FileInputStream in;
    int bytesread;
    int n;
    byte pad;
    byte [] dat;


    static byte [] srvNameinBytes;
    static byte [] srcIdinBytes ;
    static byte [] recIdinBytes ;
    static String  recId;
    String serviceName;
    String serviceBrocker;
    String sbsn;

    int payloadSize ;
    byte [] payload ;
    byte [] buffer  ;
    ANEPacket anepacket;
    TANet net;
    DSCacheControl pkt;
    int  type;
    long seq;
    int repair ;
    long maxseq ;
    long rate ;
    long file_size;
    
     
    
public Sender_Thread (String Multicast_address, ActiveSend as, String sendFileName) throws 
                    FileNotFoundException, UnknownHostException
    
    {
     serviceName = "MulticastS"; 
     serviceBrocker = "http://140.77.15.124";
     sbsn = new String (serviceBrocker + "/" + serviceName);
     srvNameinBytes = sbsn.getBytes();

     InetAddress localhost;
     localhost = InetAddress.getLocalHost();	// adresse source
     srcIdinBytes = (localhost.getHostAddress()).getBytes();
     //recId = localhost.getHostAddress();

     recId=Multicast_address;
     recIdinBytes=recId.getBytes();

     String logfile_name = "mSend.txt";
     File f2 = new File(logfile_name);

     f = new File(sendFileName);
     in = new FileInputStream(f);

     this.as=as;
     
     payloadSize = 4*1024;
     type= 0;
     seq = 0 ;
     repair = 0 ;
     maxseq = 0 ;
     file_size=f.length();
     bytesread = 0 ;
     n = 1;
     pad=1;
     dat=new byte [3500];
     
     buffer = new byte [4004];
     net = new TANet ();

     for (int i=0;i<4;i++)
	   buffer[i]=pad;

     

   }



    public void run () 
    {  
	
    try {

	while (((bytesread=in.read(dat))!=-1) && (this.isAlive()))
	    {
	       ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	       DataOutputStream dos = new DataOutputStream (baos);
	       seq++;
	       dos.writeInt(type);
	       dos.writeLong(seq);
	       dos.writeLong(maxseq);
	       dos.writeLong(rate);
	       dos.writeInt(repair);
	       dos.writeInt(bytesread);
	       dos.writeLong(file_size);
	     
	       for (int i=44;i<(bytesread+44);i++)
		   dos.write(80);
		

	       payload=baos.toByteArray();

	       for (int k=0; k<bytesread; k++ )
		  payload[k+44]= dat[k];
		 

	       net.makeANEPkt(srvNameinBytes,srcIdinBytes,recIdinBytes,recIdinBytes,recIdinBytes,payload);
	       
	       if (net.anepkt==null)
		System.out.println("c lui");
		   
	       anepacket = net.anepkt;
	       

	      
	       byte []  buffer2 ;
	       buffer2 = anepacket.marshall();
	      
	       int size   = buffer2.length; //anepacket.pktLen;
	      
	       for (int i=0;i<size;i++)
		   buffer[i+4]=buffer2[i];

	       as.write(buffer2,size);
	       System.out.println("emission du paquet "+n+" taille="+size);
	       n++;

	       
	       
	       try {
		   this.sleep(10);
	       } catch (InterruptedException e){System.out.println (e);}

	   }
       }catch (IOException e){System.out.println (e);}
      
    }
    
}



