
import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class Timers_Thread extends Thread {

    NVector nackCache;
    Unicast_Sender us;
    StreamStruct stream;
    

    public Timers_Thread (Unicast_Sender us, StreamStruct stream)
    { 
      this.us = us;
      this.stream = stream;
      this.nackCache= stream.nackCache;
    }
	 
	 
    public void run ()  
     { 
       try
	{ while ((this.isAlive())&&(stream.Session_End==0))
	  { 
	    NCacheControl nack;
	     
	    for (int i=0;i<nackCache.size();i++)
	     { 
	       nack = (NCacheControl) nackCache.elementAt(i);
		  
	       nack.timer--;
		        
	       if ((nack.timer==0)&&(nack.received==false))
		  {   
		      us.SendNack(stream.emetteur, nack.seq, stream.lo, stream.lr, stream.maxseq);
		      nack.timer=100;
		  }
	     }
		     
		  
	   try {
               this.sleep(10);
	      } catch (InterruptedException e){System.out.println (e);}
	  }
	}catch (UnknownHostException e){System.out.println(e);
	   }catch(SocketException e) {System.out.println(e);
	     }catch(IOException e) {System.out.println(e);
	     }catch (BadANEPversionException e){System.out.println(e);}
       
	System.exit (0);
     }
}



















