import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

class Timers_Control extends Thread

{
    Unicast_Sniffer us;
    Unicast_Sender usend;

    public Timers_Control (Unicast_Sniffer us) throws UnknownHostException,SocketException 
    { this.us = us;
      usend   =  us.usend;
    }

    public void Send (long seq) throws UnknownHostException, IOException
    { long lo=0;
      long lr=0;
      long maxseq=0;
      String RecepteurOriginaire=null;
      String nackDest=null;
      LinkedList LL;
      Object o;
      
      o= us.NS.get(Long.toString(seq));
      LL = (LinkedList) o;
      int i=0;
      ListIterator LI = LL.listIterator();

      while ((i<LL.size())&&(LI.hasNext()))
       { i++;
	 o= LI.next();
         Recepteur r= (Recepteur) o;
	 
	 if (r.lo>lo)
	     lo=r.lo;

	 if (r.lr>lr)
	     lr=r.lr;
	 
	 if(r.maxseq>maxseq)
	     maxseq=r.maxseq;

	 RecepteurOriginaire = r.RecepteurOriginaire;

       }

            
      if(RecepteurOriginaire!=null)
      nackDest = us.NackDest (RecepteurOriginaire);
         

      // Envoyer le NACK en mode actif avec ces paramatres ok
      if(nackDest!=null)
      usend.SendNack(nackDest,seq,lo,lr,maxseq);
    }

    public void run ()
    {
	while (isAlive())
	    {  
	      try{
		  for (Enumeration e = us.TS.elements() ; e.hasMoreElements() ;)
		       { NackCache nc= (NackCache)  e.nextElement();
		         nc.timer --;
			 //System.out.println("le paquet "+nc.seq+" timer="+nc.timer);
		      
		         if (nc.timer==0)
			  { Send(nc.seq);
			    System.out.println("Timer "+nc.seq+" expire");
			    nc.timer=75;
			  }
			}
		   }catch (UnknownHostException  e){System.out.println (e);

	     }catch (IOException e) {System.out.println (e);}


		try {
		    this.sleep(100);
		} catch (InterruptedException e){System.out.println (e);}
	    
 
	    }
    
    }

}


