
import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;

public class Unicast_Sender {


byte [] srvNameinBytes;
byte [] srcIdinBytes ;
byte [] desIdinBytes ;

DatagramSocket ds;
TANet net;
String srcId; 

long seq, lo, lr, maxseq;

ActiveSendUnicast asu;

  public Unicast_Sender () throws UnknownHostException, SocketException
   {
     String serviceName = "MulticastS"; // Nom  du Sercive Multicast
     String serviceBrocker = "http://140.77.15.124";
     String sbsn = new String (serviceBrocker + "/" + serviceName);
     srvNameinBytes = sbsn.getBytes(); 
     
     InetAddress localhost;
     localhost = InetAddress.getLocalHost();
     this.srcId = localhost.getHostAddress(); 
     this.srcIdinBytes = srcId.getBytes ();
     ds = new DatagramSocket ();
     net = new TANet ();
     asu = new ActiveSendUnicast ();
     asu.init_socket();
   }

 
  public void SendNack (String desId, long seq, long lo, long lr, long maxseq) throws UnknownHostException,
                                                                                   IOException 
   {
      byte [] payload ;
      byte [] buffer  ;
      ANEPacket anepacket;
      //DatagramPacket dp;
      int type = 1;
      
      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);
      this.seq= seq;
      this.lo = lo;
      
      desIdinBytes = desId.getBytes ();


      dos.writeInt(type);
         
      dos.writeLong(seq);
	
      dos.writeLong(lo);

      dos.writeLong(lr);

      dos.writeLong(maxseq);
       
       
      for (int i=0; i<this.srcIdinBytes.length; i++ )
	{ 
	  Marshalling.putByte(baos,this.srcIdinBytes [i]);
        } 
    
      payload=baos.toByteArray();
      

      net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
      anepacket = net.anepkt;
      buffer = anepacket.marshall();

      //System.out.println("Un Nack renvoyer vers "+desId);
      
      //InetAddress des_address = InetAddress.getByName (desId);
      //DatagramPacket dp = new DatagramPacket (buffer,buffer.length,des_address,5000);
      //DatagramSocket ds = new DatagramSocket();
      //ds.send(dp);
      asu.write(desId,5000,buffer,buffer.length);    
      
  }

    public void SendCR (String desId,long lo,long lr,long maxseq,double rtt2s,long rtt2p,
			long period,double var_rtt ) throws UnknownHostException,IOException,
							    BadANEPversionException 
    { byte [] payload ;
      byte [] buffer ;
      ANEPacket anepacket, anepkt;
      int type = 2;
      
      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);
      //this.lo = lo;
      //this.lr = lr;
      //this.maxseq=maxseq;
      
      desIdinBytes = desId.getBytes ();
      dos.writeInt(type);
      dos.writeLong(lo);
      dos.writeLong(lr);
      dos.writeLong(maxseq);
      dos.writeDouble(rtt2s);
      dos.writeLong(rtt2p);
      dos.writeLong(period);
      dos.writeDouble(var_rtt);

      for (int i=0; i<this.srcIdinBytes.length; i++ )
	{ 
	  Marshalling.putByte(baos,this.srcIdinBytes [i]);
        } 
    
      payload=baos.toByteArray();
      net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
      anepacket = net.anepkt;
      buffer    = net.anepkt.marshall();
      //System.out.println("Un CR renvoyer vers "+desId);
      asu.write(desId,5000,buffer,buffer.length);
    }



    
    public void SendRepair (String desId,ANEPacket anepkt) throws IOException, BadANEPversionException
   { byte[] buffer ;
     buffer = anepkt.marshall();
     System.out.println("Un Repair renvoyer vers "+desId);
     asu.write(desId,5001,buffer,buffer.length);
   }

    public void Init_Resp (String desId) throws IOException, BadANEPversionException 
    { 
      byte [] payload ;
      int type = 3;
      ANEPacket anepacket;     
      byte [] desIdinBytes = desId.getBytes ();     
      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);	 
      dos.writeInt(type);
      payload=baos.toByteArray();      
      net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
      anepacket = net.anepkt;
      byte []  buffer = new byte [115];
      buffer = anepacket.marshall();
      int size = buffer.length;           
      /*InetAddress dest_addr = InetAddress.getByName(desId);
      DatagramPacket dp = new DatagramPacket(buffer,size,dest_addr,5000);
      DatagramSocket ds = new DatagramSocket();
      ds.send(dp);*/     
       
      /*ActiveSendUnicast asu=new ActiveSendUnicast();
      asu.init_socket();*/
      asu.write(desId,5000,buffer,size);
    }


    public void Send_SessionEnd (String desId)throws IOException, BadANEPversionException
    { 
      byte [] payload ;
      byte [] buffer  ;
      ANEPacket anepacket;
      
      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);
      int type = 4;
      desIdinBytes = desId.getBytes ();
      dos.writeInt(type);

      payload=baos.toByteArray();
      net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
      anepacket = net.anepkt;
      buffer = anepacket.marshall();
      //asu.write(desId,5000,buffer,buffer.length);

   }


}




