
import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;

public class Unicast_Sniffer extends Thread
{
  DatagramSocket ds;
  static final int MAX_SIZE = 4000;
  static byte[] payload = new byte[MAX_SIZE];

  String File_Name="Multicast-Election.xls";
  File f ;
  FileOutputStream out ;
  Repair_Recv rr;
  
  
  static byte [] srvNameinBytes;
  static byte [] srcIdinBytes ;
  String srcId;
  String desId = null;
   

  final static Hashtable NS = new Hashtable();// Table des NACKs (Nack Structure)
  final static Hashtable TS = new Hashtable();// Table des timers des NACKs (Timers Structure)
  final static Hashtable LS = new Hashtable();// Table des liens descendants (Links Structure)


  String  parentId;
  String  RecepteurOriginaire;
  byte [] RecepteurOriginaireBytes;
  Object o;
  long lo;
  Unicast_Sender usend;
  Timers_Control tc;
  int N = 0 ;//Nombre de fils
  int M=  0 ;
  int L=  0 ;
  boolean session_end=false;

  long minlr=0;
  long minlo=0;
  long minmaxseq=0;

  long nack_time = 0 ;
  long CR_time = 0;

    Unicast_Sniffer(String parentId) throws SocketException, UnknownHostException, FileNotFoundException
    {     

     this.parentId = parentId ; // le pre de ce noeud dans l'arbre multicast

     f=new File (File_Name);
      
     String serviceName = "MulticastS"; // Nom  du Sercive Multicast
     String serviceBrocker = "http://140.77.15.124";
     String sbsn = new String (serviceBrocker + "/" + serviceName);
     this.srvNameinBytes = sbsn.getBytes();
      
     InetAddress localhost;
     localhost = InetAddress.getLocalHost();
     this.srcId = localhost.getHostAddress();
     this.srcIdinBytes = srcId.getBytes();

     out =  new FileOutputStream (f);

     this.ds = new DatagramSocket(5000);
     usend = new Unicast_Sender ();
     tc = new Timers_Control (this);
     rr = new Repair_Recv (this);
     
   }

    public void start()
    { //tc.start ();
      rr.start();
      super.start();
    }
   

    
    public int exist (LinkedList LL, String RecepteurOriginaire)
    {   Object o;
        Recepteur r;
	int index = -1;
	boolean exist = false;
	ListIterator LI = LL.listIterator();
	
	while (LI.hasNext())
	  {  index = LI.nextIndex();
	     o = LI.next();
	     r = (Recepteur) o;
 
	     if (r.RecepteurOriginaire.equals(RecepteurOriginaire))
		 {exist = true;
		  break;
		 }
		  
	  }
	
	if (exist)
	   return (index);
	else
	    return (-1);

    }

    
    



    /*Ici on traite les paquets NACKs recues*/

    public void nackPktHandler (ANEPacket anepkt) throws IOException, UnknownHostException
    {  
     
      String nackSrc=null;
      String nackDest=null;
      TANet net = new TANet();
      net.anepkt= anepkt;
      net.recoverInfoFromANEPkt();
      desId=net.destId;      
      nackSrc=net.srcId;

      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
      DataInputStream dis = new DataInputStream( bais );
      
      int type=dis.readInt();
      long seq=dis.readLong();
      long lo=dis.readLong();
      long lr=dis.readLong();
      long maxseq = dis.readLong();

      LinkedList LL= new LinkedList();
      RecepteurOriginaireBytes= new byte[16];
      RecepteurOriginaire="";
      RecepteurOriginaire=nackSrc;
      RecepteurOriginaireBytes = nackSrc.getBytes(); 
      
      Recepteur recepteur = new Recepteur ();
      recepteur.RecepteurOriginaire = RecepteurOriginaire;
      recepteur.lo = lo;
      recepteur.lr = lr;
      recepteur.maxseq = maxseq;

      
      
      if (!NS.containsKey(Long.toString(seq))) 
       { 
	 System.out.println("Nack("+seq+") from "+RecepteurOriginaire);
	 LL.clear();
         NackCache nc = new NackCache (seq);
	 TS.put(Long.toString(seq),nc);
         LL.add(recepteur);
	 NS.put(Long.toString(seq),LL);
	 long total_time=0;   
	 nackDest = NackDest (RecepteurOriginaire, seq);	 

	 if (nackDest!=null)
	 { System.out.println("NACK renvoyee a:"+nackDest);
	   usend.SendNack(nackDest,seq,lo,lr,maxseq);
	 }
	 else 
	   System.out.println("nackDest==null"); 

       }       
    
      else 
      {  
	 LL.clear();
	 o =NS.get(Long.toString(seq));
	 LL = (LinkedList) o ;
					
	 if (exist(LL,RecepteurOriginaire)==-1)  
	    {LL.addLast(recepteur); 
	     //System.out.println(""+RecepteurOriginaire+" mis dans NS");
	    } 
	 else  
	  { 
	  
	    int i = exist(LL,RecepteurOriginaire);
	    o = LL.get (i);
	    Recepteur recepteur2 = (Recepteur) o;

	    if (recepteur2.lo>lo)
		recepteur2.lo=lo;
	    
	    if (recepteur2.lr>lr)
		recepteur2.lr=lr;

	    if (recepteur2.maxseq>maxseq)
		recepteur2.maxseq=maxseq;

	    LL.set(i,recepteur2);
	  }
	 
	 NS.remove(Long.toString(seq));
	 NS.put(Long.toString(seq), LL );
	 
		 
       }	 

    }

    /*Effectue l'election*/


    public String NackDest (String RecepteurOriginair, long seq)
    { 
      Enumeration e = LS.keys();
      String srcId=null;
      LinkedList LL= new LinkedList();
      LrLo lrlo = new LrLo ();

      while (e.hasMoreElements())
	   { o = e.nextElement();
	     String addr = (String) o; 	  
	     lrlo= (LrLo) LS.get(addr);
	     //System.out.println(""+addr+" lrlo.lo="+lrlo.lo); 
	     
	     if(!addr.equals(RecepteurOriginaire))
		 { 	
		   if (lrlo.lo>200)
		       {//System.out.println(""+addr+" est elue");
		        srcId=addr;
		        break;			
		       }
		 }
	   }
	 
      if(srcId==null)
	 srcId=desId;
      
      return (srcId);

    }
    
   
   public void CRPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
    { 
      TANet net = new TANet();
      net.anepkt=anepkt;
      net.recoverInfoFromANEPkt();         
           
      M++;//Le nombre de CR recue;

      System.out.println("CR from "+net.srcId);

      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
      DataInputStream dis = new DataInputStream( bais );
      
      int type = dis.readInt();
      long lo  = dis.readLong();
      long lr  = dis.readLong();
      long maxseq = dis.readLong();
      double rtt2s = dis.readDouble();
      long rtt2p= dis.readLong();
      long period = dis.readLong();
      double var_rtt = dis.readDouble();

      if (M==1)
	minmaxseq=maxseq;
      else 
	  {  if (maxseq <minmaxseq)
	      minmaxseq= maxseq;
	  }


      if (M==1)
	  minlo=lo;
      else
	{ if(lo<minlo)
	  minlo=lo;
        }  

  
      /*if(minlr==0)
      minlr=lr;
      else
       { if(lr<minlr)
	  minlr=lr;
       }

      if(minlo==0)
      minlo=lo;
      else
      { if(lo<minlo)
	  minlo=lo;
      }
      
      if(minmaxseq==0)
      minmaxseq=maxseq;
      else
      { if(maxseq<minmaxseq)
	minmaxseq=maxseq; 
      }

      

      if (LS.size()>0)
      { o = LS.get(net.srcId);
        LrLo lrlo = (LrLo) o;

	if (lrlo.lr<lr)
	  { lrlo.lr=lr;
	    LS.remove(net.srcId);
	    LS.put(net.srcId,lrlo);
	  }
      
        if (lrlo.lo<lo)
	  {lrlo.lo=lo;
	   LS.remove(net.srcId);
	   LS.put(net.srcId,lrlo);
	  }

      }*/
       
           

      if (M==N)
      { 
        usend.SendCR(net.destId,lo,lr,minmaxseq,rtt2s,rtt2p,period,var_rtt); 
      //usend.SendCR(net.destId,minlo,minlr,minmaxseq,rtt2s,rtt2p,period,var_rtt);  
        M=0;
      } 	   

  }


   /*Traitement des paquets Init_Resp recues */

    public void Init_RespPktHandler (ANEPacket anepkt) throws IOException,BadANEPversionException
    {
      TANet net = new TANet();
      net.anepkt = anepkt;
      net.recoverInfoFromANEPkt();      
      
      if (!LS.containsKey(net.srcId)) /*C un nouveau noeud on le met dans Link List*/
	  { LrLo lrlo = new LrLo ();
	    LS.put(net.srcId, lrlo );
	    N++;
	    System.out.println("Un nouveau noeud"+net.srcId);
	  }
      usend.Init_Resp(parentId);

    }

    
    public void Session_End (ANEPacket anepkt) throws IOException, BadANEPversionException
    { TANet net = new TANet();
      net.anepkt = anepkt;
      net.recoverInfoFromANEPkt();
      net.recoverInfoFromANEPkt();
      desId=net.destId;
      L++;
           
      if (L==N)
      {  Enumeration e = LS.keys();
	 String srcId=null;

	 /*Renvoyer un Session_End a tout les noeuds descendants*/
	 
	 
	 while (e.hasMoreElements())
	     { o = e.nextElement();
	       srcId = (String) o;
	       usend.Send_SessionEnd(srcId);
	     }
	
      }

      /*Arreter le Repair Recv*/
      rr.stop();

      /*Renvoyer un Session_End au pere*/

      usend.Send_SessionEnd(desId);

      this.session_end=true;

      System.out.println("Session End");
    }



  public void HBPktHandler(ANEPacket anepkt) throws IOException, BadANEPversionException

  { TANet net = new TANet();
    net.anepkt=anepkt;
    net.recoverInfoFromANEPkt();
    ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
    DataInputStream dis = new DataInputStream( bais );
    int type = dis.readInt();
    long time_stamp = dis.readLong();
    System.out.println("HB Packet Received at"+time_stamp);
  }


    
  public void run ()
    { DatagramPacket dp = new DatagramPacket(payload, MAX_SIZE);
      ANEPacket anepkt;
      TANet net = new TANet();    
           
      
      while ((this.isAlive())&&(session_end==false))
       { 
	   try {
		  ds.receive(dp);
		  
		  anepkt=ANEPacket.unmarshall(dp.getData());
		  
		  ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
		  DataInputStream dis = new DataInputStream( bais );
		  int type = dis.readInt();

		  if (type==1)
		  nackPktHandler(anepkt);
		  
		  if (type==2)
		  {CRPktHandler(anepkt);		   
		     // System.out.println("CR Pkt Received");
		  }

		  if (type==3)
		  Init_RespPktHandler (anepkt);
		  
		  if (type==4)
		  Session_End (anepkt);

		  if (type==5)
		  HBPktHandler(anepkt);

	       }catch (IOException e) {System.out.println (e);
	         }catch (BadANEPversionException e) {System.out.println (e);}

     }

      String message = new String (""+nack_time+'\n');      

      try {
	  out.write(message.getBytes());
      } catch (IOException e){System.out.println (e);} 
      
	  
    
    }


}





